// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from event_camera_msgs:msg/EventPacket.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "event_camera_msgs/msg/event_packet.hpp"


#ifndef EVENT_CAMERA_MSGS__MSG__DETAIL__EVENT_PACKET__TRAITS_HPP_
#define EVENT_CAMERA_MSGS__MSG__DETAIL__EVENT_PACKET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "event_camera_msgs/msg/detail/event_packet__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace event_camera_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EventPacket & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: height
  {
    out << "height: ";
    rosidl_generator_traits::value_to_yaml(msg.height, out);
    out << ", ";
  }

  // member: width
  {
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << ", ";
  }

  // member: seq
  {
    out << "seq: ";
    rosidl_generator_traits::value_to_yaml(msg.seq, out);
    out << ", ";
  }

  // member: time_base
  {
    out << "time_base: ";
    rosidl_generator_traits::value_to_yaml(msg.time_base, out);
    out << ", ";
  }

  // member: encoding
  {
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << ", ";
  }

  // member: is_bigendian
  {
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << ", ";
  }

  // member: events
  {
    if (msg.events.size() == 0) {
      out << "events: []";
    } else {
      out << "events: [";
      size_t pending_items = msg.events.size();
      for (auto item : msg.events) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EventPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: height
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "height: ";
    rosidl_generator_traits::value_to_yaml(msg.height, out);
    out << "\n";
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << "\n";
  }

  // member: seq
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "seq: ";
    rosidl_generator_traits::value_to_yaml(msg.seq, out);
    out << "\n";
  }

  // member: time_base
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_base: ";
    rosidl_generator_traits::value_to_yaml(msg.time_base, out);
    out << "\n";
  }

  // member: encoding
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "encoding: ";
    rosidl_generator_traits::value_to_yaml(msg.encoding, out);
    out << "\n";
  }

  // member: is_bigendian
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_bigendian: ";
    rosidl_generator_traits::value_to_yaml(msg.is_bigendian, out);
    out << "\n";
  }

  // member: events
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.events.size() == 0) {
      out << "events: []\n";
    } else {
      out << "events:\n";
      for (auto item : msg.events) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EventPacket & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace event_camera_msgs

namespace rosidl_generator_traits
{

[[deprecated("use event_camera_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const event_camera_msgs::msg::EventPacket & msg,
  std::ostream & out, size_t indentation = 0)
{
  event_camera_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use event_camera_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const event_camera_msgs::msg::EventPacket & msg)
{
  return event_camera_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<event_camera_msgs::msg::EventPacket>()
{
  return "event_camera_msgs::msg::EventPacket";
}

template<>
inline const char * name<event_camera_msgs::msg::EventPacket>()
{
  return "event_camera_msgs/msg/EventPacket";
}

template<>
struct has_fixed_size<event_camera_msgs::msg::EventPacket>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<event_camera_msgs::msg::EventPacket>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<event_camera_msgs::msg::EventPacket>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // EVENT_CAMERA_MSGS__MSG__DETAIL__EVENT_PACKET__TRAITS_HPP_
