// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from event_camera_msgs:msg/EventPacket.idl
// generated code does not contain a copyright notice
#include "event_camera_msgs/msg/detail/event_packet__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `encoding`
#include "rosidl_runtime_c/string_functions.h"
// Member `events`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
event_camera_msgs__msg__EventPacket__init(event_camera_msgs__msg__EventPacket * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    event_camera_msgs__msg__EventPacket__fini(msg);
    return false;
  }
  // height
  // width
  // seq
  // time_base
  // encoding
  if (!rosidl_runtime_c__String__init(&msg->encoding)) {
    event_camera_msgs__msg__EventPacket__fini(msg);
    return false;
  }
  // is_bigendian
  // events
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->events, 0)) {
    event_camera_msgs__msg__EventPacket__fini(msg);
    return false;
  }
  return true;
}

void
event_camera_msgs__msg__EventPacket__fini(event_camera_msgs__msg__EventPacket * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // height
  // width
  // seq
  // time_base
  // encoding
  rosidl_runtime_c__String__fini(&msg->encoding);
  // is_bigendian
  // events
  rosidl_runtime_c__uint8__Sequence__fini(&msg->events);
}

bool
event_camera_msgs__msg__EventPacket__are_equal(const event_camera_msgs__msg__EventPacket * lhs, const event_camera_msgs__msg__EventPacket * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // height
  if (lhs->height != rhs->height) {
    return false;
  }
  // width
  if (lhs->width != rhs->width) {
    return false;
  }
  // seq
  if (lhs->seq != rhs->seq) {
    return false;
  }
  // time_base
  if (lhs->time_base != rhs->time_base) {
    return false;
  }
  // encoding
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->encoding), &(rhs->encoding)))
  {
    return false;
  }
  // is_bigendian
  if (lhs->is_bigendian != rhs->is_bigendian) {
    return false;
  }
  // events
  if (!rosidl_runtime_c__uint8__Sequence__are_equal(
      &(lhs->events), &(rhs->events)))
  {
    return false;
  }
  return true;
}

bool
event_camera_msgs__msg__EventPacket__copy(
  const event_camera_msgs__msg__EventPacket * input,
  event_camera_msgs__msg__EventPacket * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // height
  output->height = input->height;
  // width
  output->width = input->width;
  // seq
  output->seq = input->seq;
  // time_base
  output->time_base = input->time_base;
  // encoding
  if (!rosidl_runtime_c__String__copy(
      &(input->encoding), &(output->encoding)))
  {
    return false;
  }
  // is_bigendian
  output->is_bigendian = input->is_bigendian;
  // events
  if (!rosidl_runtime_c__uint8__Sequence__copy(
      &(input->events), &(output->events)))
  {
    return false;
  }
  return true;
}

event_camera_msgs__msg__EventPacket *
event_camera_msgs__msg__EventPacket__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  event_camera_msgs__msg__EventPacket * msg = (event_camera_msgs__msg__EventPacket *)allocator.allocate(sizeof(event_camera_msgs__msg__EventPacket), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(event_camera_msgs__msg__EventPacket));
  bool success = event_camera_msgs__msg__EventPacket__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
event_camera_msgs__msg__EventPacket__destroy(event_camera_msgs__msg__EventPacket * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    event_camera_msgs__msg__EventPacket__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
event_camera_msgs__msg__EventPacket__Sequence__init(event_camera_msgs__msg__EventPacket__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  event_camera_msgs__msg__EventPacket * data = NULL;

  if (size) {
    data = (event_camera_msgs__msg__EventPacket *)allocator.zero_allocate(size, sizeof(event_camera_msgs__msg__EventPacket), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = event_camera_msgs__msg__EventPacket__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        event_camera_msgs__msg__EventPacket__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
event_camera_msgs__msg__EventPacket__Sequence__fini(event_camera_msgs__msg__EventPacket__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      event_camera_msgs__msg__EventPacket__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

event_camera_msgs__msg__EventPacket__Sequence *
event_camera_msgs__msg__EventPacket__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  event_camera_msgs__msg__EventPacket__Sequence * array = (event_camera_msgs__msg__EventPacket__Sequence *)allocator.allocate(sizeof(event_camera_msgs__msg__EventPacket__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = event_camera_msgs__msg__EventPacket__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
event_camera_msgs__msg__EventPacket__Sequence__destroy(event_camera_msgs__msg__EventPacket__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    event_camera_msgs__msg__EventPacket__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
event_camera_msgs__msg__EventPacket__Sequence__are_equal(const event_camera_msgs__msg__EventPacket__Sequence * lhs, const event_camera_msgs__msg__EventPacket__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!event_camera_msgs__msg__EventPacket__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
event_camera_msgs__msg__EventPacket__Sequence__copy(
  const event_camera_msgs__msg__EventPacket__Sequence * input,
  event_camera_msgs__msg__EventPacket__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(event_camera_msgs__msg__EventPacket);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    event_camera_msgs__msg__EventPacket * data =
      (event_camera_msgs__msg__EventPacket *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!event_camera_msgs__msg__EventPacket__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          event_camera_msgs__msg__EventPacket__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!event_camera_msgs__msg__EventPacket__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
